﻿Imports System
Imports System.IO
Imports System.Windows.Forms
Imports System.Data.SqlClient
Imports System.Collections.ObjectModel
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition

' http://www.vbdotnetheaven.com/UploadFile/mahesh/CreateSQLDatabase04252005064419AM/CreateSQLDatabase.aspx

Public Class Form1

    Private ConnectionString As String = "Integrated Security=SSPI;" + "Initial Catalog=;" + "Data Source=CM\SQLEXPRESS;"
    Private reader As SqlDataReader = Nothing
    Private conn As SqlConnection = Nothing
    Private cmd As SqlCommand = Nothing
    'Private AlterTableBtn As System.Windows.Forms.Button
    Private sql As String = Nothing
    'Private CreateOthersBtn As System.Windows.Forms.Button
    Private button1 As System.Windows.Forms.Button

    Private Sub ExecuteSQLStmt(ByVal sql As String)

        Debug.Print(sql)

        ' Open the connection
        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
        ConnectionString = "Integrated Security=SSPI;" + "Data Source=CM\SQLEXPRESS;"
        conn.ConnectionString = ConnectionString
        conn.Open()
        cmd = New SqlCommand(sql, conn)
        Try
            cmd.ExecuteNonQuery()
        Catch ae As SqlException
            MessageBox.Show(ae.Message.ToString())
        End Try
    End Sub 'ExecuteSQLStmt 

    Private Sub AppExit()
        If Not (reader Is Nothing) Then
            reader.Close()
        End If
        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
    End Sub 'AppExit

    Private Sub CreateDBBtn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateDBBtn.Click

        'This method creates a new SQL Server database

        ' Create a connection
        conn = New SqlConnection(ConnectionString)
        ' Open the connection
        If conn.State <> ConnectionState.Open Then
            conn.Open()
        End If
        Dim sql As String = "CREATE DATABASE Vessels2 ON PRIMARY" + "(Name=test_data, filename = 'C:\mysql\Vessels2_data.mdf', size=3," + "maxsize=5, filegrowth=10%)log on" + "(name=Vessels2b_log, filename='C:\mysql\Vessels2_log.ldf',size=3," + "maxsize=20,filegrowth=1)"
        ExecuteSQLStmt(sql)
        'MessageBox.Show("CreateDBBtn_Click done")

    End Sub

    Private Sub CreateTableBtn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateTableBtn.Click

        Dim cownt As Integer
        Dim cownt1 As Integer
        Dim cownt2 As Integer

        ' Open the connection
        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
        'ConnectionString = "Integrated Security=SSPI;" + "Initial Catalog=Vessels2;" + "Data Source=localhost;"
        ConnectionString = "Integrated Security=SSPI;" + "Initial Catalog=Vessels2;" + "Data Source=CM\SQLEXPRESS;"
        conn.ConnectionString = ConnectionString
        conn.Open()
        sql = "CREATE TABLE Vessels" + "(ID INTEGER CONSTRAINT PKeyMyId PRIMARY KEY, " + "Name CHAR(254), UseMe BIT, VLat FLOAT, VLon FLOAT, VDateTime datetime, VSpd FLOAT, VCMG FLOAT, MaxSpeedEver FLOAT, WGS84Loc Geography)"
        cmd = New SqlCommand(sql, conn)
        'Try
        cmd.ExecuteNonQuery()
        ' Adding records the table
        'sql = "INSERT INTO Vessels(ID, Name, VLat, VLon, VDateTime, WGS84Loc) " + "VALUES (1, 'First Vessel', 5, 23.98, '1998-01-02 01:02:03.456', 'POINT(" + "1.1" + " " + "4.4" + ")') "
        'cmd = New SqlCommand(sql, conn)
        'cmd.ExecuteNonQuery()
        'sql = "INSERT INTO Vessels(ID, Name, VLat, VLon, VDateTime, WGS84Loc) " + "VALUES (153, 'Test Vessel', 6, 253.64, '" + Now.ToString("s") + "', 'POINT(" + "2.2" + " " + "4.4" + ")') "
        'cmd = New SqlCommand(sql, conn)
        'cmd.ExecuteNonQuery()
        'sql = "INSERT INTO Vessels(ID, Name, VLat, VLon, VDateTime, WGS84Loc) " + "VALUES (999, 'Data Logger', 7, 43.43, '" + DateTime.UtcNow.ToString("s") + "', 'POINT(" + "3.3" + " " + "4.4" + ")') "
        'cmd = New SqlCommand(sql, conn)
        'cmd.ExecuteNonQuery()
        'sql = "INSERT INTO Vessels(ID, Name, VLat, VLon, VDateTime, WGS84Loc) " + "VALUES (9999, 'Last Vessel', 8, 23.00, '" + DateTime.UtcNow.ToString("s") + "', 'POINT(" + "4.4" + " " + "4.4" + ")') "
        'cmd = New SqlCommand(sql, conn)
        'cmd.ExecuteNonQuery()

        For cownt = -90 To 90
            cownt1 = cownt + 90
            cownt2 = -cownt
            sql = "INSERT INTO Vessels(ID, Name, UseMe, VLon, VLat, VCMG, VDateTime, WGS84Loc) " + "VALUES (0" + cownt1.ToString("000") + ", 'Vessel " + cownt1.ToString + "a', 1, " + (2 * cownt).ToString + ", " + cownt.ToString + ", " + cownt1.ToString + ", '" + DateTime.UtcNow.ToString("s") + "', 'POINT(" + (2 * cownt).ToString + " " + cownt.ToString + ")') "
            sql = "INSERT INTO Vessels(ID, Name, UseMe, VLon, VLat, VCMG, VDateTime, WGS84Loc) " + "VALUES (0" + cownt1.ToString("000") + ", 'Vessel " + cownt1.ToString + "a', 1, " + (1 * cownt).ToString + ", " + cownt.ToString + ", " + cownt.ToString + ", '" + DateTime.UtcNow.ToString("s") + "', 'POINT(" + (1 * cownt).ToString + " " + cownt.ToString + ")') "
            cmd = New SqlCommand(sql, conn)
            cmd.ExecuteNonQuery()
            sql = "INSERT INTO Vessels(ID, Name, UseMe, VLon, VLat, VCMG, VDateTime, WGS84Loc) " + "VALUES (1" + cownt1.ToString("000") + ", 'Vessel " + cownt1.ToString + "b', 1, " + (2 * cownt).ToString + ", " + cownt2.ToString + ", " + cownt1.ToString + ", '" + DateTime.UtcNow.ToString("s") + "', 'POINT(" + (2 * cownt).ToString + " " + cownt2.ToString + ")') "
            sql = "INSERT INTO Vessels(ID, Name, UseMe, VLon, VLat, VCMG, VDateTime, WGS84Loc) " + "VALUES (1" + cownt1.ToString("000") + ", 'Vessel " + cownt1.ToString + "b', 1, " + (1 * cownt).ToString + ", " + cownt.ToString + ", " + cownt.ToString + ", '" + DateTime.UtcNow.ToString("s") + "', 'POINT(" + (1 * cownt).ToString + " " + cownt2.ToString + ")') "
            cmd = New SqlCommand(sql, conn)
            cmd.ExecuteNonQuery()
        Next
        'Catch ae As SqlException
        'MessageBox.Show(ae.Message.ToString())
        'End Try
        MessageBox.Show("CreateTableBtn_Click done")

    End Sub

    Private Sub ViewDataBtn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ViewDataBtn.Click

        '/ Open the connection
        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
        'ConnectionString = "Integrated Security=SSPI;" + "Initial Catalog=Vessels2;" + "Data Source=localhost;"
        ConnectionString = "Integrated Security=SSPI;" + "Initial Catalog=Vessels2;" + "Data Source=CM\SQLEXPRESS;"
        conn.ConnectionString = ConnectionString
        conn.Open()
        ' Create a data adapter
        Dim da As New SqlDataAdapter("SELECT * FROM Vessels", conn)
        ' Create DataSet, fill it and view in data grid
        Dim ds As New DataSet("Vessels")
        da.Fill(ds, "Vessels")
        DataGrid1.DataSource = ds.Tables("Vessels").DefaultView
        MessageBox.Show("ViewDataBtn_Click done")

    End Sub

    Private Sub CreateSPBtn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateSPBtn.Click

        sql = "CREATE PROCEDURE myProc AS" + " SELECT myName, myAddress FROM Vessels GO"
        ExecuteSQLStmt(sql)
        MessageBox.Show("CreateSPBtn_Click done")

    End Sub

    Private Sub CreateViewBtn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateViewBtn.Click

        sql = "CREATE VIEW myView AS SELECT myName FROM Vessels"
        ExecuteSQLStmt(sql)
        MessageBox.Show("CreateViewBtn_Click done")

    End Sub

    Private Sub AlterTableBtn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AlterTableBtn.Click

        ' modifies table structure - changed Name column width from 254 to 100 characters.

        sql = "ALTER TABLE Vessels ALTER COLUMN " + "Name CHAR(100) NOT NULL"
        ExecuteSQLStmt(sql)
        MessageBox.Show("AlterTableBtn_Click done")

    End Sub

    Private Sub CreateOthersBtn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateOthersBtn.Click

        sql = "CREATE UNIQUE CLUSTERED INDEX " + "myIdx ON Vessels(myName)"
        ExecuteSQLStmt(sql)
        sql = "CREATE RULE myRule " + "AS @myBalance >= 32 AND @myBalance < 60"
        ExecuteSQLStmt(sql)
        MessageBox.Show("CreateOthersBtn_Click")

    End Sub

    Private Sub DropTableBtn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DropTableBtn.Click

        Dim sql As String = "DROP TABLE Vessels"
        ExecuteSQLStmt(sql)
        MessageBox.Show("DropTableBtn_Click done")

    End Sub

    Private Sub ViewSPBtn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ViewSPBtn.Click

        '/ Open the connection
        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
        ConnectionString = "Integrated Security=SSPI;" + "Initial Catalog=Vessels2;" + "Data Source=CM\SQLEXPRESS;"
        conn.ConnectionString = ConnectionString
        conn.Open()
        ' Create a data adapter
        Dim da As New SqlDataAdapter("myProc", conn)
        ' Create DataSet, fill it and view in data grid
        Dim ds As New DataSet("SP")
        da.Fill(ds, "SP")
        DataGrid1.DataSource = ds.DefaultViewManager

        MessageBox.Show("ViewSPBtn_Click done")

    End Sub

    Private Sub ViewViewBtn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ViewViewBtn.Click

        ' Open the connection
        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
        ConnectionString = "Integrated Security=SSPI;" + "Initial Catalog=Vessels2;" + "Data Source=CM\SQLEXPRESS;"
        conn.ConnectionString = ConnectionString
        conn.Open()
        ' Create a data adapter
        Dim da As New SqlDataAdapter("SELECT * FROM myView", conn)
        ' Create DataSet, fill it and view in data grid
        Dim ds As New DataSet
        da.Fill(ds)
        DataGrid1.DataSource = ds.DefaultViewManager

        MessageBox.Show("ViewViewBtn_Click done")

    End Sub

    Private Sub btnChangePositions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChangePositions.Click

        Dim cownt As Integer

        Dim SQLString As String

        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
        'ConnectionString = "Integrated Security=SSPI;" + "Initial Catalog=Vessels2;" + "Data Source=localhost;"
        ConnectionString = "Integrated Security=SSPI;" + "Initial Catalog=Vessels2;" + "Data Source=CM\SQLEXPRESS;"
        conn.ConnectionString = ConnectionString
        conn.Open()

        ' Change the positions of the spatial data in the table.
        ' Do we have to do it one row at a time? Probably best to do it that way as that is the way it will be done in MVMSuite anyway.
        ' We have ID of 0 to 180 and 1000 to 1180
        For cownt = 0 To 180
            SQLString = "'POINT(" + (-180 + Rnd() * 360).ToString + " " + (-90 + Rnd() * 180).ToString + ")'"
            SQLString = "'POINT(" + (-90 + Rnd() * 180).ToString + " " + (-90 + Rnd() * 180).ToString + ")'"
            sql = "UPDATE Vessels SET WGS84Loc=" + SQLString + ", VCMG=" + cownt.ToString + " WHERE ID=" + cownt.ToString
            cmd = New SqlCommand(sql, conn)
            cmd.ExecuteNonQuery()
        Next
        For cownt = 1000 To 1180
            SQLString = "'POINT(" + (-180 + Rnd() * 360).ToString + " " + (-90 + Rnd() * 180).ToString + ")'"
            SQLString = "'POINT(" + (-90 + Rnd() * 180).ToString + " " + (-90 + Rnd() * 180).ToString + ")'"
            sql = "UPDATE Vessels SET WGS84Loc = " + SQLString + ", VCMG=" + (-1000 + cownt).ToString + " WHERE ID=" + cownt.ToString
            cmd = New SqlCommand(sql, conn)
            cmd.ExecuteNonQuery()
        Next

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Debug.Print(Now() + ": Timer fired")
        Timer1.Enabled = False
        btnChangePositions.PerformClick()

        Try
            WinformsMap1.Refresh()
        Catch ae As Exception
            Debug.Print(Now().ToString + " - Timer1_Tick(): " + ae.Message.ToString())
        End Try

        Debug.Print(Now() + ": Timer enabled")

        Timer1.Enabled = True

    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged

        If CheckState.Checked Then
            'testsub()
            LoadSQL2008Layer()
            Timer1.Enabled = True
        Else
            Timer1.Enabled = False
        End If
    End Sub

    Private Sub LoadSQL2008Layer()

        WinformsMap1.MapUnit = GeographyUnit.DecimalDegree

        WinformsMap1.CurrentExtent = New RectangleShape(-180, 90, -180, -90)
        WinformsMap1.BackgroundOverlay.BackgroundBrush = New GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean)

        Dim connectString As String = "Integrated Security=SSPI;" + "Initial Catalog=Vessels2;" + "Data Source=CM\SQLEXPRESS;"
        Dim sql2008Layer As New MsSql2008FeatureLayer(connectString, "Vessels", "ID") ' should this be the key layer ID or the geometry layer WGS84Loc?
        sql2008Layer.Srid = 4326
        sql2008Layer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1
        sql2008Layer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.SymbolPen = New GeoPen(GeoColor.FromArgb(255, GeoColor.StandardColors.Green), 8)
        sql2008Layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        Debug.Print(Now().ToString + ": " + sql2008Layer.FeatureIdColumn) ' this just repeats the 3rd parameter of the Dim sql2008Layer statement above.

        ' Let's just try collecting some info - I have to open the layer to make it work.
        ' If I close the layer later will this make the error go away? No - appears Open & Close don't affect adding the layer to the map?
        sql2008Layer.Open()
        sql2008Layer.MakeAllGeometriesValid()
        'Dim strResult As Dictionary
        'strResult = sql2008Layer.Validate() ' doesn't work - returns a Dictionary, whatever that is!
        Debug.Print(Now().ToString + ": " + sql2008Layer.GetFirstGeometryType.ToString) ' returns 'Point'

        'Dim OneFeature As Feature
        'Dim cownt As Integer
        'Dim fCollection As Collection(Of Feature) = sql2008Layer.FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns)
        'For cownt = 0 To fCollection.Count - 1
        'OneFeature = fCollection.Item(cownt)
        'If OneFeature.GetShape.GetCenterPoint.X > 90 Or OneFeature.GetShape.GetCenterPoint.X < -90 Then
        'Debug.Print(OneFeature.GetShape.ToString)
        'End If
        'If OneFeature.GetShape.GetCenterPoint.Y > 90 Or OneFeature.GetShape.GetCenterPoint.Y < -90 Then
        'Debug.Print(OneFeature.GetShape.ToString)
        'End If
        'Next

        sql2008Layer.Close()

        Dim inMemoryLayer As InMemoryFeatureLayer = New InMemoryFeatureLayer()
        inMemoryLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.SymbolPen = New GeoPen(GeoColor.FromArgb(255, GeoColor.StandardColors.Green), 8)
        inMemoryLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        sql2008Layer.Open()
        Dim fCollection As Collection(Of Feature) = sql2008Layer.FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns)
        For Each feature As Feature In fCollection
            inMemoryLayer.InternalFeatures.Add(feature)
        Next
        sql2008Layer.Close()
        Dim inMemoryOverlay As New LayerOverlay()
        inMemoryOverlay.Layers.Add("InMemoryFeatureLayer", inMemoryLayer)
        WinformsMap1.Overlays.Add("InMemoryOverlay", inMemoryOverlay)
        WinformsMap1.Refresh()

        Dim staticOverlay As New LayerOverlay()
        staticOverlay.Layers.Add("Sql2008Layer", sql2008Layer)
        WinformsMap1.Overlays.Add(staticOverlay)

        'Try
        WinformsMap1.Refresh()
        'Catch ae As Exception
        'Debug.Print(Now().ToString + " - LoadSQL2008Layer(): " + ae.Message.ToString())
        'End Try

    End Sub

    Sub testsub()

        Dim connectString As String = "Integrated Security=SSPI;" + "Initial Catalog=Vessels2;" + "Data Source=CM\SQLEXPRESS;"
        Dim sql2008Layer As New MsSql2008FeatureLayer(connectString, "Vessels", "ID")
        sql2008Layer.Srid = 4326
        sql2008Layer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.SymbolPen = New GeoPen(GeoColor.FromArgb(255, GeoColor.StandardColors.Green), 8)
        sql2008Layer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1
        sql2008Layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        sql2008Layer.Open()
        Dim fCollection1 As Collection(Of Feature) = sql2008Layer.FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns)
        For Each feature As Feature In fCollection1
            Dim pointShape As PointShape = DirectCast(feature.GetShape(), PointShape)
            If pointShape.X > 90 Or pointShape.X < -90 Then
                Debug.Print(pointShape.ToString)
            End If
            If pointShape.Y > 90 Or pointShape.Y < -90 Then
                Debug.Print(pointShape.ToString)
            End If
        Next

        ' CRASHES AT NEXT LINE!!!!!!!!
        Dim fCollection2 As Collection(Of Feature) = sql2008Layer.FeatureSource.GetFeaturesForDrawing(WinformsMap1.CurrentExtent, WinformsMap1.Width, WinformsMap1.Height, ReturningColumnsType.AllColumns)

        For Each feature As Feature In fCollection2
            Dim pointShape As PointShape = DirectCast(feature.GetShape(), PointShape)
            If pointShape.X > 90 Or pointShape.X < -90 Then
                Debug.Print(pointShape.ToString)
            End If
            If pointShape.Y > 90 Or pointShape.Y < -90 Then
                Debug.Print(pointShape.ToString)
            End If
        Next
        sql2008Layer.Close()

    End Sub

    Sub RefreshSQLLayer()

    End Sub
End Class
